// The Digital Keys Library  Copyright (C) 1998-2000 RITLABS S.R.L.
// DKlibDyn  Copyright (C) 1998-2000 RITLABS S.R.L.
// Interface unit to load the Digital Keys Library DLL dinamically

unit DKlibDyn;

interface uses DkLibAPI, Windows;

function  DK_LoadKeyrings(const Params: TdkLoadKeyringsParam): BOOL;
function  DK_Encode(const Params: TdkEncodeParam): BOOL;
function  DK_Decode(const Params: TdkDecodeParam): BOOL;
function  DK_Free: BOOL;
function  DK_GetLastError: DWORD;

implementation

type
  T_DK_LoadKeyrings           = function(const Params: TdkLoadKeyringsParam): BOOL; stdcall;
  T_DK_Encode                 = function(const Params: TdkEncodeParam): BOOL; stdcall;
  T_DK_Decode                 = function(const Params: TdkDecodeParam): BOOL; stdcall;
  T_DK_Free                   = function: BOOL; stdcall;
  T_DK_GetLastError           = function: DWORD; stdcall;

var
  F_DK_LoadKeyrings           : T_DK_LoadKeyrings;
  F_DK_Encode                 : T_DK_Encode;
  F_DK_Decode                 : T_DK_Decode;
  F_DK_Free                   : T_DK_Free;
  F_DK_GetLastError           : T_DK_GetLastError;

const
  DkLibDLL = 'dklib32.dll';

var
  DkLibHandle: THandle;
  DkLibLoaded: Boolean;

function __Load(A: PChar): Pointer;
begin
  Result := nil;
  if not DkLibLoaded then DkLibHandle := LoadLibrary(DkLibDLL);
  DkLibLoaded := True;
  if DkLibHandle <> 0 then Result := GetProcAddress(DkLibHandle, A);
end;

function DK_LoadKeyrings(const Params: TdkLoadKeyringsParam): BOOL;
begin
  if not Assigned(F_DK_LoadKeyrings) then F_DK_LoadKeyrings := __Load('DK_LoadKeyrings');
  if Assigned(F_DK_LoadKeyrings) then Result := F_DK_LoadKeyrings(Params) else Result := FALSE;
end;


function DK_Encode(const Params: TdkEncodeParam): BOOL;
begin
  if not Assigned(F_DK_Encode) then F_DK_Encode := __Load('DK_Encode');
  if Assigned(F_DK_Encode) then Result := F_DK_Encode(Params) else Result := FALSE;
end;

function DK_Decode(const Params: TdkDecodeParam): BOOL;
begin
  if not Assigned(F_DK_Decode) then F_DK_Decode := __Load('DK_Decode');
  if Assigned(F_DK_Decode) then Result := F_DK_Decode(Params) else Result := FALSE;
end;

function DK_Free: BOOL;
begin
  if not Assigned(F_DK_Free) then F_DK_Free := __Load('DK_Free');
  if Assigned(F_DK_Free) then Result := F_DK_Free else Result := FALSE;
end;

function DK_GetLastError: DWORD;
begin
  if not Assigned(F_DK_GetLastError) then F_DK_GetLastError := __Load('DK_GetLastError');
  if Assigned(F_DK_GetLastError) then Result := F_DK_GetLastError else Result := ERROR_DK_NOT_INITIALIZED;
end;

end.
